


#include <Wire.h>
#include <Button.h>
#include <EEPROM.h>


static int pinA = 2; 
static int pinB = 3; 
volatile byte aFlag = 0; 
volatile byte bFlag = 0; 
volatile byte encoderPos = 0; 
volatile byte oldEncPos = 0; 
volatile byte reading = 0; 
volatile byte val = 0;
char away = ' ';
char da = ' ';
float volt=0;
int steps = 257;
float R1 = 0.246;
float Rpar = 0.996;
float R2max = 11.5;
float Iadj = 0.05;
float volt_diff;
double buff_calc;




boolean store=false;

Button button = Button(4,PULLUP);


void setup() {
  Wire.begin(); // join i2c bus (address optional for master)
  pinMode(5, OUTPUT);
  pinMode(pinA, INPUT_PULLUP); 
  pinMode(pinB, INPUT_PULLUP); 
  attachInterrupt(0,PinA,RISING); 
  attachInterrupt(1,PinB,RISING); 
  val = EEPROM.read(0);
  Serial.begin(9600);   
  Wire.beginTransmission(44); // transmit to device #44
  Wire.write(byte(0x00)); 
  Wire.write(val);
  Wire.endTransmission();  
  analogWrite(5, 255-val); 
  Serial.print("Output voltage to be set : ");
        while ((Serial.available() == 0) && (millis()< 10000));  
            { volt = Serial.parseFloat(); } 
        if (Serial.available() > 0) 
            { away = Serial.read() ; }
  if (volt > 0) {    
  Serial.println(volt,2);
  Serial.println();
  Serial.print("Would you like to store this value (y/n) : "); 
       while ((Serial.available() == 0) && (millis()< 20000));  
       da = Serial.read();
       Serial.println(da);       
       if ((da == 'y') || (da == 'Y')) 
       {
       store=true;  
       Serial.println("Stored!...");
       }
       if (volt<1.672) volt = 1.672;
       if (volt>5.95) volt = 5.95;
       volt_diff = volt - 1.25;
       buff_calc = (1.25 + R1 * Iadj);
       buff_calc = buff_calc * Rpar - volt_diff * R1;
       buff_calc = buff_calc * R2max;
       buff_calc = steps / buff_calc;
       buff_calc = buff_calc * volt_diff * R1 * Rpar;
       val = int(buff_calc)-2;
       encoderPos++;
   }
}

void PinA(){
  cli(); 
  reading = PIND & 0xC; 
  if(reading == B00001100 && aFlag) { 
    encoderPos --; 
    if ( val>0 ) val--; 
    bFlag = 0; 
    aFlag = 0; 
  }
  else if (reading == B00000100) bFlag = 1; 
  sei(); 
}

void PinB(){
  cli(); 
  reading = PIND & 0xC; 
  if (reading == B00001100 && bFlag) { 
    encoderPos ++; 
    if ( val<255)  val++; 
    bFlag = 0; 
    aFlag = 0; 
  }
  else if (reading == B00001000) aFlag = 1; 
  sei(); 
}

void loop() {  
  if(button.isPressed()) store=true;
  if(oldEncPos != encoderPos) {
     analogWrite(5, 255-val);
     Wire.beginTransmission(44); // transmit to device #44
     Wire.write(byte(0x00));     // sends instruction byte 
     Wire.write(val);     
     Wire.endTransmission();     // stop transmitting
     delay(10);         
    oldEncPos = encoderPos; 
  }
  if (store) {    
       EEPROM.write(0, val);       
       digitalWrite(5, HIGH);
       delay(200);         
       for (int i=0; i <= 4; i++){  
       digitalWrite(5, LOW);
       delay(50);
       digitalWrite(5, HIGH);
       delay(50);  
       }        
       analogWrite(5, 255-val);
       store=false;
  }            
}
